#!/bin/sh
#// ***************************************************************************
#// *                                                                         *
#// *  Licensed Materials - Property of IBM                                   *
#// *  5724-L62                                                               *
#// *                                                                         *
#// *  (C) Copyright IBM Corp. 2005 All Rights Reserved.                      *
#// *                                                                         *
#// *  US Government Users Restricted Rights - Use, duplication or            *
#// *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      *
#// *                                                                         *
#// ***************************************************************************
#//
#// @(#)42   1.11   installer-ms/src/bin/install-MS.sh, am_installer-ms, claret 1/7/05 19:19:12


# (c) 2004 Cyanea Systems Corp.
# All Rights Reserved
# @author Keyuri Patel

checkNullParam()
{
        if [ $# -ne  2 ] ; then
                echo "ERROR: Value for the variable $1 is NULL."
                exit 1
        fi
}

printTitle()
{
        echo
        echo "........................$1...................."
        echo
}

checkArgs()
{
     if [ $# -ne 0 ]
     then
         if [ $1 = "-force" ]
          then
                 CYN_STRICT=false
	  fi

          if [ $1 = "-was" ]
          then
             #echo "setting cyn_appserver"
              CYN_APPSERVER=was
          fi

          if [ $1 = "-wls" ]
          then
             #echo "setting cyn_appserver"
              CYN_APPSERVER=wls
          fi
    fi
}

checkSilent()
{
	if [ $# -eq 2 ]
	then

          if [ $1 = "-silent" ]
          then
              CYN_SILENT=true
          
	     if [ -d $2 ]
	     then
		echo " $2 is a directory. Please specify correct customValues file required for the silent installation."
		exit 1
	     else		
	     	if [ -r $2 ]
	     	then 
			#echo "file $2 is readable"
			mkdir -p /tmp/ibm_am_installer_ms
			#echo "moving file"
			cp $2 /tmp/ibm_am_installer_ms/msInputs.txt
			
	     	else
			echo "File $2 doest not exist or is not readable."
		fi
	    fi
        fi
     fi
    if [ $# -eq 1 ]
    then
	if [ $1 = "-silent" ]
	then
                echo "Please pass the path of the customValues file required for the silent installation."
		echo "sh install-MS.sh [-silent customValuesFilePath]"
                exit 1
	fi
   fi
}

checkPrereqAppStatus()
{
        status=$1
        app=$2
        app_name=$3
        
        var1=100
        code=`expr $status % $var1`
	#$(($status % $var1))
         CYN_APPSERVER=$app
        if [ $code -eq 1 ]
        then
             echo "$app_name PrereqCheck Successful."
        else
                echo "$app_name PrereqCheck Failed."
                echo "Please check the logs /tmp/ibm_am_installer_ms/prereqCheck.log"
                echo "You can ignore the PrereqCheck by passing "-force"  parameter to the install-MS.sh script."
                echo "Example: sh install-MS.sh -force"
                exit 1
        fi
}         

checkPrereqStatus()
{
        status=$1
        #echo "Prereq Check returns : $status"
        if [ $status -eq  91 ]
        then  
                 echo "Invalid arguments. Usage: java PrereqCheck --strict true/false     OR "
                 echo "                   Usage: java PrereqCheck --strict true/false --appserver was/wls"
                 exit 1
        fi

        if [ $status -eq 92 ]
        then
                #echo "Environment variables WAS_HOME and WL_HOME both is defined."
                #echo "Not sure which Type of Application Server should be used for the installation."
                echo "Please pass the parameter to the install-MS.sh script."
                echo "Example: sh install-MS.sh -was (if you want to use WebSphere/Portal Application Server)."
                echo "         sh install-MS.sh -wls (if you want to use Weblogic Application Server)."
                echo "         sh install-MS.sh -was/-wls -force (if you want to ignore the PrereqCheck)."
                exit 1
        fi
        if [ $status -eq 93 ]
        then
		#echo "WAS_HOME and WL_HOME both is not defined."
                exit 1
        fi

        var1=100
        code=`expr $status / $var1`
	#$(($status/$var1))

        if [ $code = "1" ]
        then
                checkPrereqAppStatus $status was WebSphere
        fi
        if [ $code = "2" ]
        then
                checkPrereqAppStatus $status wls Weblogic
        fi
} 

INST_MS_LOG_PROPERTIES=../etc/log-applyconfig.properties
USER_JAVA_HOME=$JAVA_HOME
echo "Executing setenvInst.sh"
. ./setenvInst.sh
INST_JAVA_HOME=$JAVA_HOME
echo "INST_JAVA_HOME=$INST_JAVA_HOME"
COBRAND_1=$COBRAND
echo "COBRAND=$COBRAND_1"
status_ce=0
if [ -z "${INST_JAVA_HOME}" ]
then
	echo "$0: Error: Environment variable INST_JAVA_HOME not set."
	exit 1
fi

if [ -d ${INST_JAVA_HOME} ]
then
	echo ""
else
	echo "The INST_JAVA_HOME dir "${INST_JAVA_HOME}" you specified does not exist. Please set it to the correct location."
	exit 1
fi
JAVA_HOME_1=$INST_JAVA_HOME

if [ -d /tmp/ibm_am_installer_ms ]
then
	echo "*************************  Logs are being generated at /tmp/ibm_am_installer_ms/.   ***********************"
  rm -rf /tmp/ibm_am_installer_ms 
  mkdir -p /tmp/ibm_am_installer_ms 
else
  mkdir -p /tmp/ibm_am_installer_ms 
	echo "*************************  Logs are being generated at /tmp/ibm_am_installer_ms/   ***********************"
fi

CLASSPATH=.
CLASSPATH=${CLASSPATH}:../lib/installer-common.jar
CLASSPATH=${CLASSPATH}:../lib/ppe.installer.jar
CLASSPATH=${CLASSPATH}:../lib/ppe.installer-intf.jar
CLASSPATH=${CLASSPATH}:../lib/cyaneaaux.jar
CLASSPATH=${CLASSPATH}:../lib/common.jar
CLASSPATH=${CLASSPATH}:../embedded/support_jars/install.jar
CLASSPATH=${CLASSPATH}:../embedded/support_jars/core_util.jar
CLASSPATH=${CLASSPATH}:../embedded/support_jars/ejflt.jar
CLASSPATH=${CLASSPATH}:../embedded/support_jars/jffdc.jar
CLASSPATH=${CLASSPATH}:../embedded/support_jars/jflt.jar
CLASSPATH=${CLASSPATH}:../embedded/support_jars/jlog.jar
CLASSPATH=${CLASSPATH}:../bin/
CLASSPATH=${CLASSPATH}:../bin/setup.jar
CLASSPATH=${CLASSPATH}:../etc/
CLASSPATH=${CLASSPATH}:${INST_JAVA_HOME}/bin
echo
echo ================== Starting Installation of Managing Device ====================
echo

#---------------------------------------------------------------------------------------------------------------------------------
printTitle "Prereq Check."
#---------------------------------------------------------------------------------------------------------------------------------
 CYN_STRICT=true
 CYN_SILENT=false
args=$#

if [ $args -ne 0 ]
then
	  checkArgs $1
	  checkArgs $2
	  checkArgs $3
	  checkArgs $4
	  checkSilent $1 $2
	  checkSilent $2 $3
	  checkSilent $3 $4
fi

#echo "cyn_appserver = $CYN_APPSERVER"
#echo "CYN_= $CYN_STRICT"
#echo "silent= $CYN_SILENT"

if [ -z "${CYN_APPSERVER}" ]
then
  CYN_APPSERVER=was
fi

if [ ${CYN_APPSERVER} = "wls" ]
then
  
  JAVA_HOME=$USER_JAVA_HOME
  if [ -z "${JAVA_HOME}" ]
  then
        echo "$0: Error: Environment variable JAVA_HOME not set."
        exit 1
  fi

  if [ -d ${JAVA_HOME} ]
  then
        echo ""
  else
        echo "The JAVA_HOME dir "${JAVA_HOME}" you specified does not exist. Please set it to the correct location."
        exit 1
  fi

  echo "Running: ${INST_JAVA_HOME}/bin/java  -cp ${CLASSPATH} com.cyanea.validation.PrereqCheck --strict $CYN_STRICT  --appserver ${CYN_APPSERVER}"
  echo " "
  ${INST_JAVA_HOME}/bin/java  -cp ${CLASSPATH} com.cyanea.validation.PrereqCheck --strict $CYN_STRICT --appserver ${CYN_APPSERVER} > /tmp/ibm_am_installer_ms/prereqCheck.log
fi        
status=$?

checkPrereqStatus $status  

echo "Finished: Prereq Check."

if [ $CYN_APPSERVER = "wls" ]
then
	CLASSPATH=${CLASSPATH}:${WL_HOME}/server/lib/weblogic.jar
fi

if [ "$CYN_SILENT" = "true" ]
then
   echo " ---------- Silent Installation -----------"
#Trimming the userInput file below
ed -s /tmp/ibm_am_installer_ms/msInputs.txt <<ED_END
1,$ s/=  */=/
w
q
ED_END

ed -s /tmp/ibm_am_installer_ms/msInputs.txt <<ED_END
1,$ s/ *$//
w
q
ED_END

. ./setenvInst.sh

 if [ $CYN_APPSERVER = "was" ]
 then
    
   ${INST_JAVA_HOME}/bin/java  -Dcyanea.log.properties=log-validation.properties -cp ${CLASSPATH} com.cyanea.validation.SilentEmbedded /tmp/ibm_am_installer_ms/msInputs.txt
 
  status_sv=$?
   mv /tmp/validation.log /tmp/ibm_am_installer_ms/validation.log
   if [ $status_sv = "1" ]
   then
      echo "Validation for the Silent Embedded Installation FAILED."
      exit 1
   else
      echo "Silent Embedded Validation Successful."
   fi

#---------------- Install Embedded WAS/DB2 -----------------------------
echo "Install Embedded WAS/DB2 " 
. /tmp/ibm_am_installer_ms/msInputs.txt 
JAVA_HOME=$JAVA_HOME_1

install="NONE"
if [ $INSTALL_WAS = "true" ]
then
  if [ $INSTALL_DB2 = "true" ]
  then
	install="ALL"
  else
	install="WASONLY"
  fi
fi
if [ $INSTALL_DB2 = "true" ]
then
  if [ $INSTALL_WAS = "true" ]
  then
	install="ALL"
  else
	install="DB2ONLY"
  fi
fi
if [ $install != "NONE" ]
then
    ../embedded/scripts/embedded.sh  $install ../embedded/  ../embedded/support_jars $INST_JAVA_HOME/bin/java
fi
#-----------------------------------------------------------------------
fi 
#---- WAS part is done -----
. ./setenvInst.sh

if [ $CYN_APPSERVER = "wls" ]
then
   JAVA_HOME=$USER_JAVA_HOME
fi

 ${INST_JAVA_HOME}/bin/java  -DCOBRAND=$COBRAND_1  -Dcyanea.log.properties=log-validation.properties -cp ${CLASSPATH} com.cyanea.validation.SilentValidation -ms /tmp/ibm_am_installer_ms/msInputs.txt
   status_v=$?
   mv /tmp/validation.log /tmp/ibm_am_installer_ms/validation.log
   if [ $status_v = "1" ]
   then
      echo "Validation for the Silent Installation FAILED."
      exit 1
   else
      echo "Silent Validation Successful."
   fi
   . /tmp/ibm_am_installer_ms/msInputs.txt
   mkdir -p $AM_HOME 
   . ./setenvInst.sh
   sh install-configure.sh 
   echo . > /tmp/validation.log
   ${INST_JAVA_HOME}/bin/java  -Dcyanea.log.properties=log-validation.properties -cp ${CLASSPATH} com.cyanea.validation.Utility -checkForError /tmp/ibm_am_installer_ms/msInputs.txt
   status_ce=$?
   mv /tmp/validation.log /tmp/ibm_am_installer_ms/error.log
   status_final=0
else
  os_name=`uname`
  if [ $os_name = "HP-UX" ];
  then
    echo ""
    #echo "Interactive installer is not supported for HP-UX. Please run silent installer for HP-UX."
    #exit
  else  
    #---------------------------------------------------------------------------------------------------------------------------------
    printTitle "Gathering User Inputs: InstallShield GUI"
    #---------------------------------------------------------------------------------------------------------------------------------
   . ./setenvInst.sh
   if [ $CYN_APPSERVER = "wls" ]
   then
       JAVA_HOME=$USER_JAVA_HOME
   fi

    ${INST_JAVA_HOME}/bin/java  -DCOBRAND=$COBRAND_1 -DCYN_APPSERVER=$CYN_APPSERVER -Dcyanea.log.properties=log-inst-ms.properties -cp ${CLASSPATH}:../lib/cls.jar:setup.jar run  > /tmp/ibm_am_installer_ms/installer-ms.log 2>/tmp/ISMP.tmp
    status_gui=$?
    if [ $status_gui = "236" ]
    then
        echo "The environment variable DISPLAY is not set correctly. Please export it and proceed with the installation."
        exit 1
    fi
    
    if [ $status_gui = "232" ]
    then
        echo "-------- Installation aborted by a user ---------"
        exit 1
    fi
    status_final=0;

  fi
fi

#do the steps only if GUI is successful
if [ $status_final = "0" ]
then
#loading unser input file
. /tmp/ibm_am_installer_ms/msInputs.txt

osName=`uname`
autoDir=
autoScript=

if [ $osName = "Linux" ];
then
	autoDir=/etc/rc.d/init.d
	autoScript=am
fi

if [ $osName = "AIX" ];
then
	autoDir=/etc
	autoScript=rc.am
fi

if [ $osName = "SunOS" ];
then
	autoDir=/etc/init.d
	autoScript=am
fi

mkdir -p ${autoDir}
cp ${AM_HOME}/etc/${autoScript} ${autoDir}/${autoScript}

#change permission for cyanea user with group ownership #13846
USERGROUP=`/usr/bin/id ${JDBC_USER}| sed 's/) groups=.*//' | sed 's/.* gid=.*(//' | sed 's/)//'`
chown -R ${JDBC_USER}:${USERGROUP} ${AM_HOME}
chmod -R 750 ${AM_HOME}

chmod +x ${AM_HOME}/bin/*
#set userid bit for authenticate_OS
chmod  a-r  ${AM_HOME}/bin/authenticate*
chmod  a-w  ${AM_HOME}/bin/authenticate*
chmod  a+x  ${AM_HOME}/bin/authenticate*
chmod  u+s  ${AM_HOME}/bin/authenticate*
chown root ${AM_HOME}/bin/authenticate*

mkdir -p  $AM_HOME/logs
#13846
chown -R ${JDBC_USER}:${USERGROUP} $AM_HOME/logs

cp -r /tmp/ibm_am_installer_ms/ $AM_HOME/logs/.
rm -rf $AM_HOME/_uninst
#13846
chown -R  ${JDBC_USER}:${USERGROUP} $AM_HOME/logs/

echo "Logs have been moved from /tmp/ibm_am_installer_ms/ to $AM_HOME/logs. "
echo ================== Installation Complete. Please check log files to see if there are any errors. =====================
echo " "
sh $AM_HOME/bin/PostInstallationInstructions.sh
fi
if [ $status_ce != "0" ]
then   
   exit 1
fi
exit 0
